<?php

namespace App\DataTables;

use App\Models\VariantePiatto;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class VariantePiattoDataTableEditor extends DataTablesEditor
{
  protected $model = VariantePiatto::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'label.required' => 'Il nome è richiesto',
    'prezzo.required' => 'Il prezzo è richiesto',
    'is_attivo.required' => 'Indicare una delle due opzioni',
    'piatto_id.required' => 'Il piatto è richiesto',
    'cucina_id.required' => 'La cucina è richiesta',
    'attivita_id.required' => 'L\'attività è richiesta',
    'attivita_id.exists' => 'L\'attività non è valida',
    'piatto_id.exists' => 'Il piatto non è valido',
    'cucina_id.exists' => 'La cucina non è valida',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'label'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'prezzo' => 'required',
      'is_attivo' => 'boolean',
      'piatto_id' => 'nullable|exists:piatto,id',
      'cucina_id' => 'required|exists:cucina,id',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'label'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'prezzo' => 'required',
      'is_attivo' => 'boolean',
      'piatto_id' => 'nullable|exists:piatto,id',
      'cucina_id' => 'required|exists:cucina,id',
    ];

  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
